function [h1_opt,h2_opt]=bicvnw(x,y,ny,k,mi,h_max,h_d,c);
%CROSS-VALIDACNI metoda pro zvoleni optimalnich vyhlazovacich
%parametru h1_opt a h2_opt ve dvourozmernych NW-odhadech.
%x...dvourozmerny vektor nezavislych promennych
%y...vektor zavislych promennych
%ny,k a m ...rad jadra
%h_max...maximalni hodnota vyhlazovacich parametru
%h_d...hustota site vyhlazovacich parametru
%c...nepovinny parametr. Zadejte cele cislo a vykresli se dvourozmerne 
%NW odhady pro prave nalezene optimalni parametry do figure(cislo ktere 
%jste zadali), pokud parametr nezadate, nevykresli se.



a=x(:,1);
b=x(:,2);
m=length(a);

%je zvoleno epanecnikovo jadro
K=K_def('opt',ny,k,mi);


%jsou zvoleny vektory vyhlazovacich parametru. Minimum je zvoleno
%jako polovina nejmensi vzdalenosti.

D=sqrt(sum(abs(repmat(permute(x, [1 3 2]), [1 m 1])-repmat(permute(x, [3 1 2]), [m 1 1]) ).^2, 3));
[h_min,h_min_position]=min(min(D(D~=0)));


h1=linspace((h_min)/2,h_max,h_d);
h2=linspace((h_min)/2,h_max,h_d);


%vytvoreni matice, jejichz radky postupne vzdy vynechaji jeden prvek
q=1:1:m;
[Q]=meshgrid(q);
Q=Q-diag(diag(Q));
W=triu(Q);
E=tril(Q);
W(:,1)=[];
E(:,m)=[];
A=W+E;

%uprava promenych na "sit"
[H1,H2]=meshgrid(h1,h2);
p=zeros(size(H1));
z=p;
spodek=p;
vrsek=p; 
suma=p;

%aplikovani vzorce pro CV(H)
for j=1:m
 for f=1:m-1
     i=A(j,f);
     px1=(a(j)-a(i))./H1;
     px2=(b(j)-b(i))./H2;
     vrsek=vrsek+K_val(K,px1).*K_val(K,px2).*y(i);
     spodek=spodek+K_val(K,px1).*K_val(K,px2);
 end
 spodek(spodek==0)=1;
 z=z+vrsek./spodek;
 suma=suma+( y(j) - z ).^2;
 z=p;
 spodek=p;
 vrsek=p; 
end
suma=suma*(1/m);

%vykresleni CV-funkce

%mesh(H1,H2,suma);

%hledani minima
[f,v]=min(min(suma));
[s,g]=min(suma(:,v));
suma(g,v);
h1_opt=(h1(g));
h2_opt=(h2(v));

%pokud se zada parametr c, vykresli se odhady s optimalnimi parametry do
%figure cislo c
if (nargin>7)
    figure(c)
    binw(x,y,h1_opt,h2_opt,ny,k,mi);
end
