function[f,x,Z] = bigauss(Xi,y,h,C,xx)
%Vykresli graf dvourozmernych Gaussovych odhadu.
%Xi...dvourozmerny vektor regresoru
%y...jednorozmerny vektor zavislych promennych
%h...vyhlazovaci matice

[dim,n]=size(Xi);
if dim>n
    Xi=Xi';
    [dim,n]=size(Xi);
end
Ximin=min(Xi,[],2);
Ximax=max(Xi,[],2);
if nargin<4
    C=0;
end
if nargin<5
    for i=1:dim
        x(i,:)=linspace(Ximin(i),Ximax(i),50);
    end
else
    x=xx;
end;

% posun y
posun = mean(y);
yold = y;
y = y - posun;
%%%%%%%%%%%%
m=size(x,2);
hinv=h^(-1/2);
deth=sqrt(det(h));
if (C~=0)||(nargout==3)
    vrchZ=zeros(m);
    for i=1:n
        x_x=x-Xi(:,i)*ones(1,m);
        arg = hinv*x_x;
        [~,zz]=gausskern(arg);
        vrchZ=vrchZ+zz*y(i);
    end
    Z=vrchZ/(n*deth);
    f=diag(Z)';
else
    vrchZ=zeros(1,m);
    for i=1:n
        x_x=x-Xi(:,i)*ones(1,m);
        arg = hinv*x_x;
        [zz]=gausskern(arg);
        vrchZ=vrchZ+zz*y(i);
    end
    f=vrchZ/(n*deth);
    Z=[];
end
% navrat zpet
f = f + posun;
Z = Z + posun;
y = yold;
%%%%%%%%%%%%
if (C~=0)&&(dim==2)
    xx=x(1,:);
    yy=x(2,:);
    [X,Y]=meshgrid(xx,yy);
    figure(C);
    a=Xi(1,:);
    b=Xi(2,:);
    plot3(a,b,y,'kx');
    hold on;
    mesh(X,Y,Z);
    figure(C+1);
    contour(X,Y,Z);
    hold on;
    plot(a,b,'kx');
end;




