function[f,x,Z] = bigaussder(Xi,y,h,C,xx)
%Vykresli graf dvourozmernych Gaussovych odhadu 1. derivace.
%Xi...dvourozmerny vektor regresoru
%y...jednorozmerny vektor zavislych promennych
%h...vyhlazovaci matice

[dim,n]=size(Xi);
if dim>n
    Xi=Xi';
    [dim,n]=size(Xi);
end
Ximin=min(Xi,[],2);
Ximax=max(Xi,[],2);

if nargin<4
    C=0;
end
if nargin<5
    for i=1:dim
        x(i,:)=linspace(Ximin(i),Ximax(i),50);
    end
else
    x=xx;
end;
% posun y
posun = mean(y);
yold = y;
y = y - posun;
%%%%%%%%%%%%
m=size(x,2);
hinv=h^(-1/2);
deth=sqrt(det(h));
if (C~=0)||(nargout==3)
    vrchZx=zeros(m);
    vrchZy=zeros(m);
    for i=1:n
        x_x=x-Xi(:,i)*ones(1,m);
        arg = hinv*x_x;
        [~,zz]=gausskern(arg);
        gx = -ones(m,1)*arg(1,:).*zz;  % gradient podle x
        gy = -ones(m,1)*arg(2,:).*zz';  % gradient podle y   %%% Tady transpozice!?
        vrchZx=vrchZx+gx*y(i);
        vrchZy=vrchZy+gy*y(i);
    end
    Zx=vrchZx/(n*deth*sqrt(h(1,1)));
    fx=diag(Zx)';                                 
    Zy=vrchZy'/(n*deth*sqrt(h(2,2)));             %%% Tady transpozice!?
    fy=diag(Zy)';
 else
    vrchZx=zeros(1,m);
    vrchZy=zeros(1,m);
    for i=1:n
        x_x=x-Xi(:,i)*ones(1,m);
        arg = hinv*x_x;
        zz=gausskern(arg);
        gx = -arg(1,:).*zz;  % gradient podle x
        gy = -arg(2,:).*zz;  % gradient podle y
        vrchZx=vrchZx+gx*y(i);
        vrchZy=vrchZy+gy*y(i);
    end
    fx=vrchZx/(n*deth*sqrt(h(1,1)));
    Zx=[];
    fy=vrchZy/(n*deth*sqrt(h(2,2)));
    Zy=[];
end
% navrat zpet
y = yold;
%%%%%%%%%%%%
if (C~=0)&&(dim==2)
    xx=x(1,:);
    yy=x(2,:);
    [X,Y]=meshgrid(xx,yy);
    figure(C);
%     a=Xi(1,:);
%     b=Xi(2,:);
%     plot3(a,b,y,'kx');
%     hold on;
    mesh(X,Y,Zx);
    colorbar;
    figure(C+1);
    contour(X,Y,Zx);
%     hold on;
%     plot(a,b,'kx');
    colorbar;
    figure(C+2);
%     a=Xi(1,:);
%     b=Xi(2,:);
%     plot3(a,b,y,'kx');
%     hold on;
    mesh(X,Y,Zy);
    colorbar;
    figure(C+3);
    contour(X,Y,Zy);
%     hold on;
%     plot(a,b,'kx');
    colorbar;
end;
f = [fx;fy]; 
Z = [Zx;Zy];  % fliplr????



