function[f,x,Z] = bigaussnw(Xi,y,h,C,xx,Xipuv)
%Vykresli graf dvourozmernych Gaussovych odhadu - NW.
%Xi...dvourozmerny vektor regresoru
%y...jednorozmerny vektor zavislych promennych
%h...vyhlazovaci matice

[dim,n]=size(Xi);
if (dim>n)&&(n>1)
    Xi=Xi';
    [dim,n]=size(Xi);
end
Ximin=min(Xi,[],2);
Ximax=max(Xi,[],2);

if Xi(2,1) == Xi(2,2)
    transponuj = 1;
else
    transponuj = 0;
end
%transponuj = 1;
% [X,Y] = meshgrid(unique(Xi(1,:)), unique(Xi(2,:)));
% Xi = [X(:),Y(:)]';

%-----------------------------------
if nargin<4
    C=0;
end
if nargin<5
    for i=1:dim
        x(i,:)=linspace(Ximin(i),Ximax(i),50);
    end
    [a,b] = meshgrid(x(1,:),x(2,:));
    x = [a(:)';b(:)'];
else
    x=xx;
end;
if nargin<6
    Xipuv=Xi;
end
% zjistime, jak je vlastne zadano Xi
m=size(x,2);
% difer = x(:,2:end) - x(:,1:end-1);
% nula = any(difer(1,:)==0);
% if nula
%     pocetX2 = length(find(difer(1,:)~=0))+1;
% else
%     pocetX2 = 1;
% end
pocetX2 = length(unique(x(2,:)));
pocetX1 = length(unique(x(1,:)));
%pocetX1 = m/pocetX2
%     pom1=Xi(1,1:pocetX1:end);
%     pom2=Xi(2,1:pocetX1);

% posun y
% posun = mean(y);
% yold = y;
% y = y - posun;
%%%%%%%%%%%%

hinv=h^(-1/2);
%deth=sqrt(det(h));
if (C~=0)||(nargout==3)
    vrchZ=zeros(pocetX1,pocetX2);
    spodZ=zeros(pocetX1,pocetX2);
    for i=1:n
        x_x=x-Xi(:,i)*ones(1,m);
        arg = hinv*x_x;
        [~,zz]=gausskern(arg);
        zz = reshape(zz',pocetX1,pocetX2);
        vrchZ=vrchZ+zz*y(i);
        spodZ=spodZ+zz;
    end
    Z=vrchZ./spodZ;
    f=diag(Z)';
else
    vrchZ=zeros(1,m);
    spodZ=zeros(1,m);
    for i=1:n
        x_x=x-Xi(:,i)*ones(1,m);
        arg = hinv*x_x;
        [zz]=gausskern(arg);
        vrchZ=vrchZ+zz*y(i);
        spodZ=spodZ+zz;
    end
    f=vrchZ./spodZ;
    Z=[];
end
if transponuj == 1
    Z = Z';
end
% % navrat zpet
% f = f + posun;
% %Z = Z + posun;
% y = yold;
%%%%%%%%%%%%
if dim==2
    X = reshape(x(1,:),pocetX1,pocetX2);
    Y = reshape(x(2,:),pocetX1,pocetX2);
%    Z = reshape(f,pocetX1,pocetX2);
    %     xx=x(1,:);
    %     yy=x(2,:);
    %     [X,Y]=meshgrid(xx,yy);
    if C~=0
        figure(C);
        a=Xipuv(1,:);
        b=Xipuv(2,:);
        barva = [0,0.25,0.5];
        scatter3(a,b,y,'filled','MarkerEdgeColor',barva,'MarkerFaceColor',barva);
        %        plot3(a,b,y,'kx');
        hold on
        %        mesh(X,Y,Z,'FaceColor',[1.0, 0.56, 0.0],'EdgeColor','none')
        mesh(X,Y,Z);
        alpha(0.4)
        figure(C+1);
        contour(X,Y,Z);
        hold on;
        plot(a,b,'kx');
    end
end;




