function binw(x,y,h1,h2,ny,k,mi);
%Vykresli graf dvourozmernych Nadaraya-Watsonovych odhadu.
%x...dvourozmerny vektor regresoru
%y...jednorozmerny vektor zavislych promennych
%h1,h2...vyhlazovaci parametry
%ny,k,mi...rad jadra

m=length(x);
a=x(:,1);
b=x(:,2);
K=K_def('opt',ny,k,mi);
c=linspace(min(a),max(a));
d=linspace(min(b),max(b));
[C,D]=meshgrid(c,d);
z=zeros(size(C));
vrsek=z;
spodek=z;
[C,D]=meshgrid(c,d);
for i=1:m
    px1=(a(i)-C)./h1;
    px2=(b(i)-D)./h2;
    vrsek=vrsek+K_val(K,px1).*K_val(K,px2).*y(i)./(h1*h2);
    spodek=spodek+K_val(K,px1).*K_val(K,px2)./(h1*h2);
end
spodek(spodek==0)=1;
z=vrsek./spodek;
plot3(a,b,y,'kx');
hold on;
mesh(C,D,z);
