function[f,x,Z] = bipchfull(Xi,y,ny,k,mi,h,styl,C,xx)
%Vykresli graf dvourozmernych Pristley-Chaovych odhadu.
%Xi...dvourozmerny vektor regresoru
%y...jednorozmerny vektor zavislych promennych
%h...vyhlazovaci matice
%ny,k,mi...rad jadra (0,2,1) - Epanechnik

[dim,n]=size(Xi);
if dim>n
    Xi=Xi';
    [dim,n]=size(Xi);
end
Ximin=min(Xi,[],2);
Ximax=max(Xi,[],2);
if nargin<7
    styl='prod';
end
if nargin<8
    C=0;
end
if nargin<9
    for i=1:dim
        x(i,:)=linspace(Ximin(i),Ximax(i));
    end
else
    x=xx;
end;
m=size(x,2);
hinv=h^(-1/2);
if C~=0
    vrchZ=zeros(m);
    for i=1:n
        x_x=x-Xi(:,i)*ones(1,m);
        arg = hinv*x_x;
        switch styl
            case 'prod'
                [~,zz]=productkern(ny,k,mi,arg);
            case 'sphe'
                [~,zz]=spherickern(ny,k,mi,arg);
            case 'gaus'
                [~,zz]=gausskern(arg);
        end;
        vrchZ=vrchZ+zz*y(i);
    end
    Z=vrchZ/((det(h))^(1/2)*n);
    f=diag(Z)';
else
    vrchZ=zeros(1,m);
    for i=1:n
        x_x=x-Xi(:,i)*ones(1,m);
        arg = hinv*x_x;
        switch styl
            case 'prod'
                zz=productkern(ny,k,mi,arg);
            case 'sphe'
                zz=spherickern(ny,k,mi,arg);
            case 'gaus'
                zz=gausskern(arg);
        end;
        vrchZ=vrchZ+zz*y(i);
    end
    f=vrchZ/((det(h))^(1/2)*n);
    Z=[];
end
if (C~=0)&&(dim==2)
    xx=x(1,:);
    yy=x(2,:);
    [X,Y]=meshgrid(xx,yy);
    figure(C);
    a=Xi(1,:);
    b=Xi(2,:);
    plot3(a,b,y,'kx');
    hold on;
    mesh(X,Y,Z);
    figure(C+1);
    contour(X,Y,Z);
    hold on;
    plot(a,b,'kx');
end;




