function[xmin] = hledejminimum(Xi,y,tol,omez)
% pokus o hledani minima funkce dvou promenych pomoci jadroveho odhadu 1.
% derivace

[dim,n]=size(Xi);
if dim>n
    Xi=Xi';
    [dim,n]=size(Xi);
end
Ximin=min(Xi,[],2);
Ximax=max(Xi,[],2);

if nargin < 4
    odec = (Ximax - Ximin)/n;
    omez = [Ximin+odec,Ximax-odec];
end

for i=1:dim
    x(i,:)=linspace(Ximin(i),Ximax(i),50);
end

m=length(x);

h = [1/n 0;0 1/n];
[~,~,Zder] = bigaussder(Xi,y,h,0,x);
Zx = Zder(1:m,:);
Zy = Zder(m+1:end,:);
xx=x(1,:);
yy=x(2,:);
[X,Y]=meshgrid(xx,yy);

figure;
xcont = contour(X,Y,Zx,-.001:.001:.001);
close(gcf);
figure
ycont = contour(X,Y,Zy,-.001:.001:.001);
close(gcf);
vybx = vyber_kontury(xcont,0);
vyby = vyber_kontury(ycont,0);

vybx(:,or((omez(1,1)>=vybx(1,:)),(vybx(1,:)>=omez(1,2))))=[];
vybx(:,or((omez(2,1)>=vybx(2,:)),(vybx(2,:)>=omez(2,2))))=[];
vyby(:,or((omez(1,1)>=vyby(1,:)),(vyby(1,:)>=omez(1,2))))=[];
vyby(:,or((omez(2,1)>=vyby(2,:)),(vyby(2,:)>=omez(2,2))))=[];

if isempty(vyby)||isempty(vybx)
    error('Nemuzu najit! Zkus upravit omezeni.')
end

for i = 1:length(vyby)
    vzdalenosti(i,:) = sqrt((vybx(1,:)-vyby(1,i)).^2+(vybx(2,:)-vyby(2,i)).^2);
end

if nargin <3
    tol = min(min(vzdalenosti));
end

[indx,indy] = find(vzdalenosti<=tol);

xmin = [vybx(:,indy),vyby(:,indx)];

