function [h1_opt,h2_opt]=penf_gcv(x,y,ny,k,mi,h_min,h_max,h_d,c);
%RICEOVA penalizacni funkce pro zvoleni optimalnich vyhlazovacich
%parametru h1_opt a h2_opt ve dvourozmernych NW-odhadech.
%x...dvourozmerny vektor nezavislych promennych
%y...vektor zavislych promennych
%ny,k a m ...rad jadra
%h_min...minimlni hodnota vyhlazovacich parametru
%h_max...maximalni hodnota vyhlazovacich parametru
%h_d...hustota site vyhlazovacich parametru
%c...nepovinny parametr. Zadejte cele cislo a vykresli se dvourozmerne 
%NW odhady pro prave nalezene optimalni parametry do figure(cislo ktere 
%jste zadali), pokud parametr nezadate, nevykresli se.



a=x(:,1);
b=x(:,2);
m=length(a);

%je zvoleno epanecnikovo jadro
K=K_def('opt',ny,k,mi);


%jsou zvoleny vektory vyhlazovacich parametru. 

h1=linspace(h_min,h_max,h_d);
h2=linspace(h_min,h_max,h_d);

%vytvoreni site pomocnych parametru a definice prazdnych pomocnych
%promennych
[H1,H2]=meshgrid(h1,h2);
p=zeros(size(H1));
vrsek=p;
spodek=p;
NW_odhad=p;
rss=p;
penf2=p;
g=0;

%aplikace RSS penalizovane pomoci GCV pen. fce.
for i=1:m
    for j=1:m
        px1=(a(i)-a(j))./H1;
        px2=(b(i)-b(j))./H2;
        vrsek=vrsek+K_val(K,px1).*K_val(K,px2).*y(j);
        spodek=spodek+K_val(K,px1).*K_val(K,px2);
    end
penf_vrsek=K_val(K,0).*K_val(K,0);
spodek(spodek==0)=1;
NW_odhad=(vrsek./spodek);

penf_sp=penf_vrsek./(spodek);


penf=(1-penf_sp).^(-2);
kontrola= y(i)-NW_odhad;

rss=rss + ((kontrola).^2).*penf;
NW_odhad=p;
spodek=p;
vrsek=p; 
end
rss=(1/m)*rss;


%nalezeni minima
[f,v]=min(min(rss));
[s,g]=min(rss(:,v));
h1_opt=(h1(g))
h2_opt=(h2(v))


%pokud se zada parametr c, vykresli se odhady s optimalnimi parametry do
%figure cislo c
if (nargin>8)
    figure(c)
    binw(x,y,h1_opt,h2_opt,ny,k,mi);
end



