function r=r_exact(a,om)
% function r=r1(a,b,om)
% function 'r' for parametric xurve xi:
% xi(t)=sin(om*t)+(a+2*pi)t+b, t is from [-1,1]
% a,b are from (0,1), om is from (0,2pi)
% r1(xi)=int_{-1}^{1}|xi'(t)|(1-cos(pi*t))dt

r=zeros(size(a));

I1=find(om==pi);
if ~isempty(I1)
  r(I1)=3*pi+2*a(I1);
end

I1=find(om~=pi);
if ~isempty(I1)
  r(I1)=4*pi + 2*a(I1) + 4*sin(om(I1)) -2*pi^2*sin(om(I1))./(pi^2 -om(I1).^2);
end
