load singapore_falls

%bigauss(Xi,y,eye(2)/100,1)

h =newtonregress(Xi,y',1)

% sitcvregress(Xi,y')
% sitetpenregress(Xi,y')

[~,xx,c]=bigaussnw(Xi,y,h/8);

figure

X1 = Xi(1,:);
X2 = Xi(2,:);
barva = [0,0.25,0.5];
scatter3(X1,X2,y,'filled','MarkerEdgeColor',barva,'MarkerFaceColor',barva);
grid off
%pause
hold on
x1fit = linspace(min(xx(1,:)),max(xx(1,:)),50);
x2fit = linspace(min(xx(2,:)),max(xx(2,:)),50);
[X1FIT,X2FIT] = meshgrid(x1fit,x2fit);

mesh(X1FIT,X2FIT,c')%,'FaceColor',[1.0, 0.56, 0.0],'EdgeColor','none')
alpha(0.4)

minx = min(Xipuv(1,:));
maxx = max(Xipuv(1,:));
XtickLabel = (minx:maxx);
miny = min(Xipuv(2,:));
maxy = max(Xipuv(2,:));
YtickLabel = (miny:maxy);
set(gca,'Xtick',(XtickLabel-minx+1)/(maxx-minx+1));
set(gca,'XtickLabel',num2str(XtickLabel'));
set(gca,'Ytick',(YtickLabel-miny+1)/(maxy-miny+1));
set(gca,'YtickLabel',num2str(YtickLabel'));
xlabel('vyska')
ylabel('mira zraneni')

% odhad derivace
h1 =newtonregressder(Xi,y',2)

% h2 = sitcvregressder(Xi,y')
% h3 = sitricepenregressder(Xi,y')

[~,xxder,cder]=bigaussder(Xi,y,h1/2,0,xx);
m = length(xx)
Zx = cder(1:50,:);
Zy = cder(51:end,:);

figure

contour(X1FIT,X2FIT,c','showtext','on');
hold on;

cc = caxis(gca);
x1fit = xxder(1,:);
x2fit = xxder(2,:);
[X1FIT,X2FIT] = meshgrid(x1fit,x2fit);
[Cx,hx] = contour(X1FIT,X2FIT,Zx,-.001:.001:.001,'Linewidth',2.5,'Color','red','linestyle',':');
[Cy,hy] = contour(X1FIT,X2FIT,Zy,-.001:.001:.001,'Linewidth',2.5,'Color','blue','linestyle',':');
caxis(cc);%colorbar

p1 = plot(Cx','Linewidth',2.5,'Color','red','linestyle',':');
p2 = plot(Cy','Linewidth',2.5,'Color','blue','linestyle',':');
legend([p1(1),p2(1)],'\delta / \delta x = 0','\delta / \delta y = 0','Location', 'SouthWest')

set(gca,'Xtick',(XtickLabel-minx+1)/(maxx-minx+1));
set(gca,'XtickLabel',num2str(XtickLabel'));
set(gca,'Ytick',(YtickLabel-miny+1)/(maxy-miny+1));
set(gca,'YtickLabel',num2str(YtickLabel'));
xlabel('vyska')
ylabel('mira zraneni')
xlabel('height')
ylabel('ISS')

return

% parametricky
X1 = Xi(1,:);
X2 = Xi(2,:);

x1fit = linspace(min(X1),max(X1),50);
x2fit = linspace(min(X2),max(X2),50);

[X1FIT,X2FIT] = meshgrid(x1fit,x2fit);
X = [ones(42,1),X1',X2',X1'.^2,X2'.^2];
b = regress(y,X);
YFIT = b(1) + b(2)*X1FIT + b(3)*X2FIT + b(4)*X1FIT.^2 + b(5)*X2FIT.^2;


figure
barva = [0,0.25,0.5];
scatter3(X1,X2,y,'filled','MarkerEdgeColor',barva,'MarkerFaceColor',barva);
grid off
%pause
hold on
mesh(X1FIT,X2FIT,YFIT)%,'FaceColor',[1.0, 0.56, 0.0],'EdgeColor','none')
alpha(0.4)

% minx = min(Xipuv(1,:));
% maxx = max(Xipuv(1,:));
% XtickLabel = (minx:maxx);
% miny = min(Xipuv(2,:));
% maxy = max(Xipuv(2,:));
% YtickLabel = (miny:maxy);
set(gca,'Xtick',(XtickLabel-minx+1)/(maxx-minx+1));
set(gca,'XtickLabel',num2str(XtickLabel'));
set(gca,'Ytick',(YtickLabel-miny+1)/(maxy-miny+1));
set(gca,'YtickLabel',num2str(YtickLabel'));
xlabel('vyska')
ylabel('mira zraneni')


%save singapore_falls YFIT -append -v6
